DHCLIENT(8)

NAME
dhclient - Dynamic Host Configuration Protocol (DHCP) client

SYNOPSIS
dhclient [-dnrv] [-c file] [-i options] interface

DESCRIPTION
dhclient uses the Dynamic Host Configuration Protocol (DHCP), or its predecessor BOOTP, to configure a network interface. Information typically provided via DHCP includes IPv4 address and subnet mask, default route, and domain name server.

dhclient can be run on the command line, or at boot time by specifying ‘dhcp’ in the appropriate hostname.if(5) file.

The options are as follows:

-c file
    Specify an alternate location to /etc/dhclient.conf for the configuration file. If file is the empty string then no configuration file is read.

-d  Do not daemonize. If this option is specified, dhclient will run in the foreground and log to stderr.

-i options
    dhclient will ignore values provided by leases for the options specified. This list will supplement ignore statements in dhclient.conf(5). options must be a comma separated list of valid option names.

-n  Configtest mode. Only check the configuration file for validity.

-r  Release the current lease back to the server it came from. dhclient exits after removing the active lease from /var/db/dhclient.leases.<IFNAME>, deleting the address the lease caused to be added to the interface, and sending a DHCPRELEASE packet to the server that supplied the lease.

    If there is no dhclient controlling the specified interface, or dhclient has no active lease configured, no action is performed.

-v  Causes dhclient to show more information about interactions with the DHCP server and what network configuration changes are attempted after accepting a lease. -v is implied if either -d or -n is present.

The DHCP protocol allows a host to contact a central server which maintains a list of IP addresses which may be assigned on one or more subnets. A DHCP client may request an address from this pool, and then use it on a temporary basis for communication on the network. The DHCP protocol also provides a mechanism whereby a client can learn important details about the network to which it is attached, such as the location of a default router, the location of a name server, and so on.

On startup, dhclient reads /etc/dhclient.conf for configuration instructions. It then attempts to configure the network interface interface with DHCP. The special value “egress” may be used instead of a network interface name. In this case dhclient will look for the network interface currently in the interface group “egress” and configure it with DHCP. If there is more than one network interface in the egress group, dhclient will exit with an error.

When configuring the interface, dhclient attempts to remove any existing addresses, gateway routes that use the interface, and non-permanent arp(8) entries. dhclient automatically exits whenever a new dhclient is run on the same interface.

Once the interface is configured, dhclient constructs a resolv.conf(5) file. It does this only if any of the options domain-name, domain-name-servers, or domain-search are present (note that these options may be offered by the DHCP server but suppressed by dhclient.conf(5)). If a resolv.conf is constructed, dhclient appends any contents of the /etc/resolv.conf.tail file, which are read once at start up. The constructed resolv.conf is copied into /etc/resolv.conf whenever the default route goes out the interface dhclient is running on. dhclient monitors the system for changes to the default route and re-checks whether it should write its resolv.conf when possible changes are detected.

In order to keep track of leases across system reboots and server restarts, dhclient keeps a list of leases it has been assigned in the /var/db/dhclient.leases.<IFNAME> file. IFNAME represents the network interface of the DHCP client (e.g. em0), one for each interface. On startup, after reading the dhclient.conf(5) file, dhclient reads the leases file to refresh its memory about what leases it has been assigned.

Old leases are kept around in case the DHCP server is unavailable when dhclient is first invoked (generally during the initial system boot process). In that event, old leases from the dhclient.leases.<IFNAME> file which have not yet expired are tested, and if they are determined to be valid, they are used until either they expire or the DHCP server becomes available.

A mobile host which may sometimes need to access a network on which no DHCP server exists may be preloaded with a lease for a fixed address on that network. When all attempts to contact a DHCP server have failed, dhclient will try to validate the static lease, and if it succeeds, it will use that lease until it is restarted.

A mobile host may also travel to some networks on which DHCP is not available but BOOTP is. In that case, it may be advantageous to arrange with the network administrator for an entry on the BOOTP database, so that the host can boot quickly on that network rather than cycling through the list of old leases.

FILES
/etc/dhclient.conf
    DHCP client configuration file
/etc/hostname.XXX
    interface-specific configuration files
/var/db/dhclient.leases.<IFNAME>
    database of acquired leases

SEE ALSO
dhclient.conf(5), dhclient.leases(5), hostname.if(5), dhcpd(8), dhcrelay(8), ifconfig(8)

STANDARDS
R. Droms, October 1993, RFC 1534, Interoperation Between DHCP and BOOTP.

R. Droms, March 1997, RFC 2131, Dynamic Host Configuration Protocol.

S. Alexander, R. Droms, March 1997, RFC 2132, DHCP Options and BOOTP Vendor Extensions.

T. Lemon, S. Cheshire, November 2002, RFC 3396, Encoding Long Options in the Dynamic Host Configuration Protocol (DHCPv4).

T. Lemon, S. Cheshire, B. Volz, December 2002, RFC 3442, The Classless Static Route Option for Dynamic Host Configuration Protocol (DHCP) version 4.

N. Swamy, G. Halwasia, P. Jhingram, January 2013, RFC 6842, Client Identifier Option in DHCP Server Replies.

AUTHORS
-nosplit dhclient was written by Ted Lemon <mellon@fugue.com> and Elliot Poger <elliot@poger.com>.

The current implementation was reworked by Henning Brauer <henning@openbsd.org>.